diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/transform.h b/strongswan-5.2.0/src/libstrongswan/crypto/transform.h
index a585e97..56d60fc 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/transform.h
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/transform.h
@@ -13,6 +13,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
+
 /**
  * @defgroup transforms transforms
  * @{ @ingroup crypto
@@ -38,7 +60,8 @@ enum transform_type_t {
 	PSEUDO_RANDOM_FUNCTION = 2,
 	INTEGRITY_ALGORITHM = 3,
 	DIFFIE_HELLMAN_GROUP = 4,
-	EXTENDED_SEQUENCE_NUMBERS = 5
+	EXTENDED_SEQUENCE_NUMBERS = 5,
+	KEY_TRANSFORM_ALGORITHM = 6
 };
 
 /**
diff --git a/strongswan-5.2.0/src/libstrongswan/eap/eap.c b/strongswan-5.2.0/src/libstrongswan/eap/eap.c
index 64b5dbe..da50a7e 100644
--- a/strongswan-5.2.0/src/libstrongswan/eap/eap.c
+++ b/strongswan-5.2.0/src/libstrongswan/eap/eap.c
@@ -12,7 +12,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include <stdlib.h>
 #include <errno.h>
@@ -26,7 +48,7 @@ ENUM(eap_code_names, EAP_REQUEST, EAP_FAILURE,
 	"EAP_RESPONSE",
 	"EAP_SUCCESS",
 	"EAP_FAILURE",
-);
+); 
 
 ENUM(eap_code_short_names, EAP_REQUEST, EAP_FAILURE,
 	"REQ",
@@ -59,7 +81,8 @@ ENUM_NEXT(eap_type_names, EAP_TNC, EAP_TNC, EAP_MSTLV,
 	"EAP_TNC");
 ENUM_NEXT(eap_type_names, EAP_PT_EAP, EAP_PT_EAP, EAP_TNC,
 	"EAP_PT_EAP");
-ENUM_NEXT(eap_type_names, EAP_EXPANDED, EAP_DYNAMIC, EAP_PT_EAP,
+ENUM_NEXT(eap_type_names, EAP_BSTS, EAP_DYNAMIC, EAP_PT_EAP,
+	"EAP_BSTS",
 	"EAP_EXPANDED",
 	"EAP_EXPERIMENTAL",
 	"EAP_RADIUS",
@@ -90,7 +113,8 @@ ENUM_NEXT(eap_type_short_names, EAP_TNC, EAP_TNC, EAP_MSTLV,
 	"TNC");
 ENUM_NEXT(eap_type_short_names, EAP_PT_EAP, EAP_PT_EAP, EAP_TNC,
 	"PT");
-ENUM_NEXT(eap_type_short_names, EAP_EXPANDED, EAP_DYNAMIC, EAP_PT_EAP,
+ENUM_NEXT(eap_type_short_names, EAP_BSTS, EAP_DYNAMIC, EAP_PT_EAP,
+	"BSTS",
 	"EXP",
 	"XP",
 	"RAD",
@@ -121,6 +145,7 @@ eap_type_t eap_type_from_string(char *name)
 		{"pt",			EAP_PT_EAP},
 		{"dynamic",		EAP_DYNAMIC},
 		{"radius",		EAP_RADIUS},
+		{"bsts",		EAP_BSTS},
 	};
 
 	for (i = 0; i < countof(types); i++)
@@ -167,7 +192,7 @@ eap_vendor_type_t *eap_vendor_type_from_string(char *str)
 			continue;
 		}
 		vendor = strtoul(part, &end, 0);
-		if (*end != '\0' || errno)
+		if (*end != '\0' || errno);
 		{
 			DBG1(DBG_LIB, "invalid EAP vendor: %s", part);
 			type = 0;
diff --git a/strongswan-5.2.0/src/libstrongswan/eap/eap.h b/strongswan-5.2.0/src/libstrongswan/eap/eap.h
index 08d88ba..0048300 100644
--- a/strongswan-5.2.0/src/libstrongswan/eap/eap.h
+++ b/strongswan-5.2.0/src/libstrongswan/eap/eap.h
@@ -14,6 +14,28 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  */
+ 
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup leap eap
@@ -68,6 +90,7 @@ enum eap_type_t {
 	EAP_MSTLV = 33,
 	EAP_TNC = 38,
 	EAP_PT_EAP = 54,
+	EAP_BSTS = 253,
 	EAP_EXPANDED = 254,
 	EAP_EXPERIMENTAL = 255,
 	/** not a method, but an implementation providing different methods */
diff --git a/strongswan-5.2.0/src/libstrongswan/plugins/x509/x509_cert.c b/strongswan-5.2.0/src/libstrongswan/plugins/x509/x509_cert.c
index bdc8234..90eba61 100644
--- a/strongswan-5.2.0/src/libstrongswan/plugins/x509/x509_cert.c
+++ b/strongswan-5.2.0/src/libstrongswan/plugins/x509/x509_cert.c
@@ -16,7 +16,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #define _GNU_SOURCE
 
@@ -1465,7 +1487,7 @@ static bool parse_certificate(private_x509_cert_t *this)
 				}
 				break;
 			case X509_OBJ_SIGNATURE:
-				this->signature = object;
+				this->signature = chunk_skip(object, 1);
 				break;
 			default:
 				break;
@@ -2046,6 +2068,7 @@ static bool generate(private_x509_cert_t *cert, certificate_t *sign_cert,
 	/* select signature scheme */
 	cert->algorithm = hasher_signature_algorithm_to_oid(digest_alg,
 								sign_key->get_type(sign_key));
+
 	if (cert->algorithm == OID_UNKNOWN)
 	{
 		return FALSE;
@@ -2155,7 +2178,7 @@ static bool generate(private_x509_cert_t *cert, certificate_t *sign_cert,
 	}
 
 	/* add subjectKeyIdentifier to CA and OCSP signer certificates */
-	if (cert->flags & (X509_CA | X509_OCSP_SIGNER | X509_CRL_SIGN))
+	if (cert->flags & (X509_CA | X509_OCSP_SIGNER | X509_CRL_SIGN) || cert->flags == 0)
 	{
 		chunk_t keyid;
 
@@ -2170,7 +2193,7 @@ static bool generate(private_x509_cert_t *cert, certificate_t *sign_cert,
 	}
 
 	/* add the keyid authKeyIdentifier for non self-signed certificates */
-	if (sign_cert)
+	if (sign_cert || cert->flags & X509_CA)
 	{
 		chunk_t keyid;
 
diff --git a/strongswan-5.2.0/src/libstrongswan/plugins/x509/x509_crl.c b/strongswan-5.2.0/src/libstrongswan/plugins/x509/x509_crl.c
index d6057c3..38070c4 100644
--- a/strongswan-5.2.0/src/libstrongswan/plugins/x509/x509_crl.c
+++ b/strongswan-5.2.0/src/libstrongswan/plugins/x509/x509_crl.c
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "x509_crl.h"
 
@@ -347,7 +369,7 @@ static bool parse(private_x509_crl_t *this)
 				break;
 			}
 			case CRL_OBJ_SIGNATURE:
-				this->signature = object;
+				this->signature = chunk_skip(object, 1);
 				break;
 			default:
 				break;
@@ -470,7 +492,14 @@ METHOD(certificate_t, issued_by, bool,
 	{
 		chunk_t fingerprint;
 
-		if (!key->get_fingerprint(key, KEYID_PUBKEY_SHA1, &fingerprint) ||
+		cred_encoding_type_t type = KEYID_PUBKEY_SHA1;
+
+		if (key->get_type(key) == KEY_BIGN)
+		{
+			type = KEYID_PUBKEY_BELT;
+		}
+
+		if (!key->get_fingerprint(key, type, &fingerprint) ||
 			!chunk_equals(fingerprint, this->authKeyIdentifier))
 		{
 			return FALSE;
diff --git a/strongswan-5.2.0/src/libstrongswan/tests/suites/test_crypter.c b/strongswan-5.2.0/src/libstrongswan/tests/suites/test_crypter.c
index 4e7550a..e02fb48 100644
--- a/strongswan-5.2.0/src/libstrongswan/tests/suites/test_crypter.c
+++ b/strongswan-5.2.0/src/libstrongswan/tests/suites/test_crypter.c
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "test_suite.h"
 
@@ -34,6 +56,11 @@ static crypter_oid_t oids[] = {
 	{ OID_AES128_CBC, ENCR_AES_CBC, 128 },
 	{ OID_AES192_CBC, ENCR_AES_CBC, 192 },
 	{ OID_AES256_CBC, ENCR_AES_CBC, 256 },
+	{ OID_GOST28147_CTR, ENCR_GOST28147_CTR, 256 },
+	{ OID_GOST28147_CFB, ENCR_GOST28147_CFB, 256 },
+	{ OID_BELT_CBC, ENCR_BELT_CBC, 256 },
+	{ OID_BELT_CFB, ENCR_BELT_CFB, 256 },
+	{ OID_BELT_CTR, ENCR_BELT_CTR, 256 },
 	{ OID_CAMELLIA128_CBC, ENCR_CAMELLIA_CBC, 128 },
 	{ OID_CAMELLIA192_CBC, ENCR_CAMELLIA_CBC, 192 },
 	{ OID_CAMELLIA256_CBC, ENCR_CAMELLIA_CBC, 256 }
diff --git a/strongswan-5.2.0/src/libstrongswan/tests/suites/test_hasher.c b/strongswan-5.2.0/src/libstrongswan/tests/suites/test_hasher.c
index 41a9d64..8290f5f 100644
--- a/strongswan-5.2.0/src/libstrongswan/tests/suites/test_hasher.c
+++ b/strongswan-5.2.0/src/libstrongswan/tests/suites/test_hasher.c
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "test_suite.h"
 
@@ -35,6 +57,7 @@ static hasher_oid_t oids[] = {
 	{ OID_SHA256, HASH_SHA256, KEY_ANY },
 	{ OID_SHA384, HASH_SHA384, KEY_ANY },
 	{ OID_SHA512, HASH_SHA512, KEY_ANY },
+	{ OID_BELT_HASH, BELT_HASH, KEY_ANY },
 	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_ANY },
 	{ OID_MD2_WITH_RSA, HASH_MD2, KEY_RSA },
 	{ OID_MD5_WITH_RSA, HASH_MD5, KEY_RSA },
diff --git a/strongswan-5.2.0/src/libstrongswan/utils/debug.c b/strongswan-5.2.0/src/libstrongswan/utils/debug.c
index e8c9e6b..d2f8b7b 100644
--- a/strongswan-5.2.0/src/libstrongswan/utils/debug.c
+++ b/strongswan-5.2.0/src/libstrongswan/utils/debug.c
@@ -12,12 +12,34 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  */
+ 
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include <stdarg.h>
 
 #include "debug.h"
 
-ENUM(debug_names, DBG_DMN, DBG_LIB,
+ENUM(debug_names, DBG_DMN, DBG_CNT,
 	"DMN",
 	"MGR",
 	"IKE",
@@ -36,9 +58,10 @@ ENUM(debug_names, DBG_DMN, DBG_LIB,
 	"APP",
 	"ESP",
 	"LIB",
+	"CNT",
 );
 
-ENUM(debug_lower_names, DBG_DMN, DBG_LIB,
+ENUM(debug_lower_names, DBG_DMN, DBG_CNT,
 	"dmn",
 	"mgr",
 	"ike",
@@ -57,6 +80,7 @@ ENUM(debug_lower_names, DBG_DMN, DBG_LIB,
 	"app",
 	"esp",
 	"lib",
+	"cnt",
 );
 
 /**
diff --git a/strongswan-5.2.0/src/libstrongswan/utils/debug.h b/strongswan-5.2.0/src/libstrongswan/utils/debug.h
index f1c8c70..513a4b8 100644
--- a/strongswan-5.2.0/src/libstrongswan/utils/debug.h
+++ b/strongswan-5.2.0/src/libstrongswan/utils/debug.h
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup debug debug
@@ -68,6 +90,8 @@ enum debug_t {
 	DBG_ESP,
 	/** libstrongswan */
 	DBG_LIB,
+	/** contact plugins */
+	DBG_CNT,	
 	/** number of groups */
 	DBG_MAX,
 	/** pseudo group with all groups */
diff --git a/strongswan-5.2.0/src/libstrongswan/utils/identification.c b/strongswan-5.2.0/src/libstrongswan/utils/identification.c
index 46ac7e8..931ffe6 100644
--- a/strongswan-5.2.0/src/libstrongswan/utils/identification.c
+++ b/strongswan-5.2.0/src/libstrongswan/utils/identification.c
@@ -13,7 +13,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include <string.h>
 #include <stdio.h>
@@ -71,13 +93,18 @@ static const x501rdn_t x501rdns[] = {
 	{"C", 					OID_COUNTRY,				ASN1_PRINTABLESTRING},
 	{"L", 					OID_LOCALITY,				ASN1_PRINTABLESTRING},
 	{"ST",					OID_STATE_OR_PROVINCE,		ASN1_PRINTABLESTRING},
+	{"Street",				OID_STREET,					ASN1_PRINTABLESTRING},
 	{"O", 					OID_ORGANIZATION,			ASN1_PRINTABLESTRING},
 	{"OU", 					OID_ORGANIZATION_UNIT,		ASN1_PRINTABLESTRING},
 	{"T", 					OID_TITLE,					ASN1_PRINTABLESTRING},
 	{"D", 					OID_DESCRIPTION,			ASN1_PRINTABLESTRING},
 	{"N", 					OID_NAME,					ASN1_PRINTABLESTRING},
 	{"G", 					OID_GIVEN_NAME,				ASN1_PRINTABLESTRING},
+	{"PC", 					OID_POSTAL_CODE,			ASN1_PRINTABLESTRING},
 	{"I", 					OID_INITIALS,				ASN1_PRINTABLESTRING},
+	{"IdentityCard", 		OID_IDENTITY_CARD,			ASN1_PRINTABLESTRING},
+	{"Nick", 				OID_NICK,					ASN1_PRINTABLESTRING},
+	{"Pseudonym",			OID_PSEUDONYM,				ASN1_PRINTABLESTRING},
 	{"dnQualifier", 		OID_DN_QUALIFIER,			ASN1_PRINTABLESTRING},
 	{"ID", 					OID_UNIQUE_IDENTIFIER,		ASN1_PRINTABLESTRING},
 	{"EN", 					OID_EMPLOYEE_NUMBER,		ASN1_PRINTABLESTRING},
@@ -210,10 +237,12 @@ METHOD(enumerator_t, rdn_part_enumerate, bool,
 		{OID_COUNTRY,			ID_PART_RDN_C},
 		{OID_LOCALITY,			ID_PART_RDN_L},
 		{OID_STATE_OR_PROVINCE,	ID_PART_RDN_ST},
+		{OID_STREET, 			ID_PART_RDN_STR},
 		{OID_ORGANIZATION,		ID_PART_RDN_O},
 		{OID_ORGANIZATION_UNIT,	ID_PART_RDN_OU},
 		{OID_TITLE,				ID_PART_RDN_T},
 		{OID_DESCRIPTION,		ID_PART_RDN_D},
+		{OID_POSTAL_CODE,		ID_PART_RDN_PC},
 		{OID_NAME,				ID_PART_RDN_N},
 		{OID_GIVEN_NAME,		ID_PART_RDN_G},
 		{OID_INITIALS,			ID_PART_RDN_I},
@@ -221,6 +250,9 @@ METHOD(enumerator_t, rdn_part_enumerate, bool,
 		{OID_UNIQUE_IDENTIFIER,	ID_PART_RDN_ID},
 		{OID_EMAIL_ADDRESS,		ID_PART_RDN_E},
 		{OID_EMPLOYEE_NUMBER,	ID_PART_RDN_EN},
+		{OID_IDENTITY_CARD,		ID_PART_RDN_IC},
+		{OID_NICK,				ID_PART_RDN_NICK},
+		{OID_PSEUDONYM,			ID_PART_RDN_PSEUDONYM},
 	};
 
 	while (this->inner->enumerate(this->inner, &oid, &strtype, &inner_data))
diff --git a/strongswan-5.2.0/src/libstrongswan/utils/identification.h b/strongswan-5.2.0/src/libstrongswan/utils/identification.h
index e624468..a85edfa 100644
--- a/strongswan-5.2.0/src/libstrongswan/utils/identification.h
+++ b/strongswan-5.2.0/src/libstrongswan/utils/identification.h
@@ -13,7 +13,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup identification identification
@@ -191,6 +213,16 @@ enum id_part_t {
 	ID_PART_RDN_ST,
 	/** Title RDN of a DN */
 	ID_PART_RDN_T,
+	/** Addres in state */
+	ID_PART_RDN_STR,
+	/** Postal code */
+	ID_PART_RDN_PC,
+	/** Identitu Card */
+	ID_PART_RDN_IC,
+	/** Nick */
+	ID_PART_RDN_NICK,
+	/** Pseudonym */
+	ID_PART_RDN_PSEUDONYM
 };
 
 /**
diff --git a/strongswan-5.2.0/src/starter/confread.c b/strongswan-5.2.0/src/starter/confread.c
index 17dca66..9038d3d 100644
--- a/strongswan-5.2.0/src/starter/confread.c
+++ b/strongswan-5.2.0/src/starter/confread.c
@@ -13,7 +13,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include <sys/types.h>
 #include <sys/stat.h>
@@ -33,15 +55,15 @@
 #include "files.h"
 #include "parser/conf_parser.h"
 
-#define IKE_LIFETIME_DEFAULT         10800 /* 3 hours */
-#define IPSEC_LIFETIME_DEFAULT        3600 /* 1 hour */
+#define IKE_LIFETIME_DEFAULT          36000/* 10 hours */
+#define IPSEC_LIFETIME_DEFAULT        36000 /* 10 hour */
 #define SA_REPLACEMENT_MARGIN_DEFAULT  540 /* 9 minutes */
 #define SA_REPLACEMENT_FUZZ_DEFAULT    100 /* 100% of margin */
 #define SA_REPLACEMENT_RETRIES_DEFAULT   3
 #define SA_REPLAY_WINDOW_DEFAULT        -1 /* use charon.replay_window */
 
-static const char ike_defaults[] = "aes128-sha1-modp2048,3des-sha1-modp1536";
-static const char esp_defaults[] = "aes128-sha1,3des-sha1";
+static const char ike_defaults[] = "gost28147_ctr-gost_mac-prfbrng_ctr-modp2048,";
+static const char esp_defaults[] = "gost28147_ctr-gost_mac,";
 
 static const char firewall_defaults[] = IPSEC_SCRIPT " _updown iptables";
 
